Public Class Form1

    Private Sub txt_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDecimal.TextChanged, txtBinary.TextChanged, txtHexadecimal.TextChanged, txtOctal.TextChanged
        DisplayValue(sender)
    End Sub

    ' Display the value in the indicated control in
    ' the other controls.
    Private Sub DisplayValue(ByVal source As TextBox)
        ' Don't recurse.
        Static ignore_events As Boolean = False
        If ignore_events Then Exit Sub
        ignore_events = True

        ' Get the value.
        Dim value As Long
        Try
            Select Case source.Name
                Case "txtDecimal"
                    value = Convert.ToInt64(source.Text)
                Case "txtHexadecimal"
                    value = Convert.ToInt64(source.Text, 16)
                Case "txtOctal"
                    value = Convert.ToInt64(source.Text, 8)
                Case "txtBinary"
                    value = Convert.ToInt64(source.Text.Replace(" ", ""), 2)
            End Select
        Catch ex As Exception
            MessageBox.Show("Error parsing input" & vbCrLf & ex.Message, _
                "Input Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try

        ' Display the value in different formats.
        If source.Name <> "txtDecimal" Then
            txtDecimal.Text = value.ToString()
        End If
        If source.Name <> "txtHexadecimal" Then
            txtHexadecimal.Text = value.ToString("X")
        End If
        If source.Name <> "txtOctal" Then
            txtOctal.Text = Oct$(value)
        End If
        If source.Name <> "txtBinary" Then
            txtBinary.Text = LongToBinary(value)
        End If

        ignore_events = False
    End Sub

    ' Convert this Long value into a binary string.
    Private Function LongToBinary(ByVal long_value As Long, Optional ByVal separate_bytes As Boolean = True) As String
        ' Convert into hex.
        Dim hex_string As String = long_value.ToString("X")

        ' Zero-pad to a full 16 characters.
        hex_string = New String("0", 16 - hex_string.Length) & hex_string

        ' Read the hexadecimal digits
        ' one at a time from right to left.
        Dim result_string As String = ""
        For digit_num As Integer = 0 To 15
            ' Convert this hexadecimal digit into a
            ' binary nibble.
            Dim digit_value As Integer = Integer.Parse(hex_string.Substring(digit_num, 1), Globalization.NumberStyles.HexNumber)

            ' Convert the value into bits.
            Dim factor As Integer = 8
            Dim nibble_string As String = ""
            For bit As Integer = 0 To 3
                If digit_value And factor Then
                    nibble_string &= "1"
                Else
                    nibble_string &= "0"
                End If
                factor \= 2
            Next bit

            ' Add the nibble's string to the left of the
            ' result string.
            result_string &= nibble_string
        Next digit_num

        ' Add spaces between bytes if desired.
        If separate_bytes Then
            Dim tmp As String = ""
            For i As Integer = 0 To result_string.Length - 8 Step 8
                tmp &= result_string.Substring(i, 8) & " "
            Next i
            result_string = tmp.Substring(0, tmp.Length - 1)
        End If

        ' Return the result.
        Return result_string
    End Function
End Class
